// chard.c

#include <race.h>

void create() { seteuid(getuid()); }
void setup_char(object ob)
{
	string race;
	mapping my;

	if( !stringp(race = ob->query("race")) ) {
		race = "H";
		ob->set("race", "H");
	}
		
	switch(race) {
		case "ɨȤH":
		case "H":
			HUMAN_RACE->setup_human(ob);
			break;
		case "]":
			MONSTER_RACE->setup_monster(ob);
			break;
		case "~":
			BEAST_RACE->setup_beast(ob);
			break;
		default:
			error("Chard: undefined race " + race + ".\n");
	}

	my = ob->query_entire_dbase();

	if( undefinedp(my["gin"]) ) my["gin"] = my["max_gin"];
	if( undefinedp(my["kee"]) ) my["kee"] = my["max_kee"];
	if( undefinedp(my["sen"]) ) my["sen"] = my["max_sen"];

	if( undefinedp(my["eff_gin"]) ) my["eff_gin"] = my["max_gin"];
	if( undefinedp(my["eff_kee"]) ) my["eff_kee"] = my["max_kee"];
	if( undefinedp(my["eff_sen"]) ) my["eff_sen"] = my["max_sen"];

	if( !ob->query_max_encumbrance() )
		ob->set_max_encumbrance( my["str"] * 5000 );

	ob->reset_action();
}

varargs object make_corpse(object victim, object killer)
{
	object corpse, *inv;

	if( victim->is_ghost() ) return 0;

	corpse = new(CORPSE_OB);
	corpse->set_name( victim->name(1) + "", ({ "corpse" }) );
	corpse->set("long", victim->long()
		+ "MӡM" + gender_pronoun(victim->query("gender")) 
		+ "wgFMuѤU@RRabo̡C\n");
	corpse->set("age", victim->query("age"));
	corpse->set("gender", victim->query("gender"));
	corpse->set("victim_name", victim->name(1));
	corpse->set_weight( victim->query_weight() );
	corpse->set_max_encumbrance( victim->query_max_encumbrance() );
	corpse->move(environment(victim));
	
	inv = all_inventory(victim);
	inv->owner_is_killed(killer);
	inv -= ({ 0 });
	inv->move(corpse);

	return corpse;
}
