// combatd.c

#pragma optimize all

#include <ansi.h>
#include <skill.h>
#include <weapon.h>
#include <combat.h>

inherit F_DBASE;

string *dodge_msg = ({
	"OM$p$lFXoC\n",
	"OQ$pFa}FC\n",
	"O$nl@M{F}hC\n",
	"OQ$pή׶}C\n",
	"O$nwǳơMW}C\n",
});

string *parry_msg = ({
	"uťuv@nMQ$p}FC\n",
	"Guva@nQ$p׶}FC\n",
	"OQ$nΤ⤤Lb[}C\n",
	"O$nl@MΤ⤤Lb}C\n",
});

string *unarmed_parry_msg = ({
	"OQ$p}FC\n",
	"GQ$p׶}FC\n",
});

string *guard_msg = ({
	CYN "$N`$nʡMϴM|XC\n" NOR,
	CYN "$Nn$n@|@ʡMHɷǳƵoʧաC\n" NOR,
	CYN "$Nwwaʸ}BMQnX$n}C\n" NOR,
	CYN "$Nؤan$nʧ@MMi𪺳̨ήɾC\n" NOR,
	CYN "$NCCaʵ۸}BMXC\n" NOR,
});

string *catch_hunt_msg = ({
	YEL "$NM$nHۨ~Mߨ襴F_ӡT\n" NOR,
	YEL "$N$njܡRuicMSOATv\n" NOR,
	YEL "$NM$n@IMGܤNF_ӡT\n" NOR,
	YEL "$N@h$nMuv@nĤFLӡT\n" NOR,
	YEL "$N@$nMhF@hMjsRuڮ_FATv\n" NOR
});

void create()
{
	seteuid(getuid());
	set("name", "԰F");
	set("id", "combatd");
}

string damage_msg(int damage, string type)
{
	string str;

//	return "y " + damage + " I" + type + "C\n";

	if( damage == 0 ) return "GSyˮ`C\n";

	switch( type ) {
	case "":
	case "ζ":
		if( damage < 10 ) return "GuOa}$p֦סC\n";
		else if( damage < 20 ) return "Gb$p$lX@DӪ岪C\n";
		else if( damage < 40 ) return "Guva@nX@DˤfT\n";
		else if( damage < 80 ) return "Guva@nX@DOOˤfT\n";
		else if( damage < 160 ) return "Guva@nX@DSS`ˤfMqo$NyAT\n";
		else return "Guť$n@nGzM$wwb$p$lX@D`ΨiȶˤfTT\n";
		break;
	case "":
		if( damage < 10 ) return "GuOa}$p֦סC\n";
		else if( damage < 20 ) return "Gb$p$lX@ӳФfC\n";
		else if( damage < 40 ) return "GuPva@nJF$n$lo\\T\n";
		else if( damage < 80 ) return "GuPva@ni$n$lM$pѦۥDahFXBT\n";
		else if( damage < 160 ) return "GuPva@nM$wwb$p$lX@ӦUk]KT\n";
		else return "Guť$n@nGzM$wwb$p$lӥXMAqoaTT\n";
		break;
	case "":
		if( damage < 10 ) return "GuOaIMaǵyLFIC\n";
		else if( damage < 20 ) return "Gb$p$ly@BCC\n";
		else if( damage < 40 ) return "G@RM$n$lnɸ~F@ѰT\n";
		else if( damage < 80 ) return "G@RM$neF@nMYFpT\n";
		else if( damage < 120 ) return "Guyva@nM$nhFBT\n";
		else if( damage < 160 ) return "Go@Uuyva@no$nshFnXBMt@ILˡT\n";
		else if( damage < 240 ) return "GaM$nuzva@nRX@fAT\n";
		else return "Guťuyva@nTM$n@_뭸FXhTT\n";
		break;
	default:
		if( !type ) type = "ˮ`";
		if( damage < 10 ) str =  "GuOjjy@BL";
		else if( damage < 20 ) str = "GyL";
		else if( damage < 30 ) str = "Gy@B";
		else if( damage < 50 ) str = "Gy@BY";
		else if( damage < 80 ) str = "GyᬰY";
		else if( damage < 120 ) str = "Gy۷Y";
		else if( damage < 170 ) str = "GyQY";
		else if( damage < 230 ) str = "GyY";
		else str =  "GyD`iȪY";
		return str + type + "T\n";
	}
}

string eff_status_msg(int ratio)
{
	if( ratio==100 ) return HIG "ݰ_ӮRաMèSˡC" NOR;
	if( ratio > 95 ) return HIG "GFIˡMLq~ݤjXӡC" NOR;
	if( ratio > 90 ) return HIY "ݰ_ӥiFIˡC" NOR;
	if( ratio > 80 ) return HIY "FXBˡMLGäêơC" NOR;
	if( ratio > 60 ) return HIY "ˤMݰ_ӪpäӦnC" NOR;
	if( ratio > 40 ) return HIR "𮧲ʭMʧ@}láMݨөҨ˵۹ꤣC" NOR;
	if( ratio > 30 ) return HIR "wg˲ֲ֡MbjO伵ۤˤUhC" NOR;
	if( ratio > 20 ) return HIR "F۷ˡMuȷ|ͩRMIC" NOR;
	if( ratio > 10 ) return RED "˭UwgH伵MݴNn˦baWC" NOR;
	if( ratio > 5  ) return RED "˹LMwgaa@MRbiFC" NOR;
	return RED "˹LMwgpMHɳi_C" NOR;
}

string status_msg(int ratio)
{
	if( ratio==100 ) return HIG "ݰ_ӥROM@I]֡C" NOR;
	if( ratio > 95 ) return HIG "GǯhΡMOMQOC" NOR;
	if( ratio > 90 ) return HIY "ݰ_ӥi঳ǲ֤FC" NOR;
	if( ratio > 80 ) return HIY "ʧ@G}lIFMOMC" NOR;
	if( ratio > 60 ) return HIY "ݼNNMݰ_ӪpäӦnC" NOR;
	if( ratio > 40 ) return HIR "GQhΡMݨӻݭnnn𮧤FC" NOR;
	if( ratio > 30 ) return HIR "wg@Y}ҼˡMbjO伵ۤˤUhC" NOR;
	if( ratio > 20 ) return HIR "ݰ_ӤwgOqߤFC" NOR;
	if( ratio > 10 ) return RED "nY̸BnnױצaíMݴNn˦baWC" NOR;
	return RED "wgJbgAMHɳiL˷whC" NOR;
}

varargs void report_status(object ob, int effective)
{
	if( effective ) 
		message_vision( "( $N" + eff_status_msg(
			(int)ob->query("eff_kee") * 100 / (int)ob->query("max_kee") ) 
			+ " )\n", ob);
	else
		message_vision( "( $N" + status_msg(
			(int)ob->query("kee") * 100 / (int)ob->query("max_kee") ) 
			+ " )\n", ob);
}

// This function calculates the combined skill/combat_exp power of a certain
// skill. This value is used for A/(A+B) probability use.
varargs int skill_power(object ob, string skill, int usage)
{
	int status, level, power;

	if( !living(ob) ) return 0;

	level = ob->query_skill(skill);

	switch(usage) {
		case SKILL_USAGE_ATTACK:
			level += ob->query_temp("apply/attack");
			break;
		case SKILL_USAGE_DEFENSE:
			level += ob->query_temp("apply/defense");
			break;
	}

	if( !level ) return (int)ob->query("combat_exp") / 2;

	if( (status = ob->query("max_sen")) > 0 )
		power = (level*level*level) / 3 * (int)ob->query("sen") / status;
	else
		power = (level*level*level) / 3;

	return power + ob->query("combat_exp");
}

// do_attack()
//
// Perform an attack action. This function is called by fight() or as an
// interface for some special utilize in quests.
//
varargs int do_attack(object me, object victim, object weapon, int attack_type)
{
	object ob;
	mapping my, your, action;
	string limb, *limbs, result, attack_skill, dodge_skill;
	int ap, dp, pp, skill, damage, damage_bonus, defense_factor;
	int wounded = 0;
	int fierceness;

	my = me->query_entire_dbase();
	your = victim->query_entire_dbase();

	//
	// (1) get the action
	//
	action = me->query("actions");
	if( !mapp(action) ) {
		CHANNEL_D->do_channel( this_object(), "sys",
			sprintf("%s lost heart beat: bad action = %O\n",
				me->name(1), me->query("actions", 1)));
		error("Combat: action unavailable.\n");
	}
	result = "\n" + action["action"] + "T\n";

	//
	// (2) get the combat skill
	//
	if( objectp(weapon) )	attack_skill = weapon->query("skill_type");
	else					attack_skill = "unarmed";

	//
	// (3) get the target limb
	//
	limbs = victim->query("limbs");
	limb = limbs[random(sizeof(limbs))];

	//
	// (4) calculate the Attack Point(AP) for the attacker.
	//
	ap = skill_power(me, attack_skill, SKILL_USAGE_ATTACK);
	if( ap < 1) ap = 1;

	//
	// (5) calculate the Dodge Point(DP) for the defender
	//
	dp = skill_power(victim, "dodge", SKILL_USAGE_DEFENSE);
	if( dp < 1 ) dp = 1;

	// If we are enforced, expense it now.
	if( my["force_factor"] 
	&&	my["force"] >= my["force_factor"] )
		my["force"] -= my["force_factor"];

	//
	// (6) Fight!
	//     Give us a chance of AP/(AP+DP) to "hit" our opponent. Since both
	//     AP and DP are greater than zero, so we always have chance to hit
	//     or be hit.
	//
	if( random(ap + dp) < dp ) { 		// Does the victim dodge this hit?

		if( stringp(dodge_skill = victim->query_skill_mapped("dodge")) )
			result += SKILL_D(dodge_skill)->query_dodge_msg(limb);
		else
			result += dodge_msg[random(sizeof(dodge_msg))];

		if( dp < ap && (!userp(victim) || !userp(me)) 
		&&	random(your["gin"]*100/your["max_gin"] + your["int"]) > 50 ) {
			your["combat_exp"] += 1;
			victim->improve_skill("dodge", 1);
		}

		// This is for NPC only. NPC have chance to get exp when fail to hit.
		if( (ap < dp) && !userp(me) ) {
			if( random(my["int"]) > 15 ) my["combat_exp"] += 1;
			me->improve_skill(attack_skill, random(my["int"]));
		}
		damage = RESULT_DODGE;

	} else {

		if( !victim->query_temp("weapon") ) {
			if( weapon ) pp = 0;
			else pp = skill_power(victim, "unarmed", SKILL_USAGE_DEFENSE);
		} else {
			pp = skill_power(victim, "parry", SKILL_USAGE_DEFENSE);
			if( !weapon ) pp *= 2;
		}
		if( pp < 1 ) pp = 1;

		if( random(ap + pp)< pp ) {

			result += weapon? parry_msg[random(sizeof(parry_msg))]
				: unarmed_parry_msg[random(sizeof(unarmed_parry_msg))];

			if( dp < ap && (!userp(victim) || !userp(me)) 
			&&	random(your["gin"]*100/your["max_gin"] + your["int"]) > 50 ) {
				your["combat_exp"] += 1;
				victim->improve_skill("parry", 1);
			}
			damage = RESULT_PARRY;

		} else {

			damage = me->query_temp("apply/damage");
			damage_bonus = my["str"];

			if( action["damage"] ) damage += action["damage"] * damage / 100;

			// Check if we are enforced.
			if( my["force_factor"] > 0 ) {
				int fap, fdp;
				string defender_force;

				fap = skill_power(me, "force");
				fdp = skill_power(victim, "force");

				if( your["force_factor"] > 0 && random(fap + fdp) < fdp ) {
					damage_bonus = 0;
					result += "O$NۦҧtlQ$nHOƸѡM";
					if( fdp < random(fap) )
						victim->improve_skill("force", 1);
				} else
					damage_bonus += 
						my["force_factor"] 
						* (my["force"] > my["max_force"] ? my["max_force"]: my["force"])
						* (100 + action["force"]) / 20000;
			}

			if( damage_bonus > 0
			&&	your["force_factor"] > 0
			&&	your["force"] >= your["force_factor"] ) {
				result += "$nϥΤOwIwƸ$NODM";
				damage_bonus -= your["force_factor"] * (your["force"]/100);
				your["force"] -= your["force_factor"];
			}

			// Apply the damage bonus to the damage we'll inflict.
			if( damage_bonus > 0 ) damage += (damage_bonus + random(damage_bonus))/2;
			if( damage < 0 ) damage = 0;

			// If we're attacking while victim is busy, add 50% bamage.
			if( attack_type==TYPE_QUICK ) damage += damage / 2;
			// Else if we are fiercy enough, make another 25% damage.
			else if( random(my["bellicosity"]/10) > your["cps"] + your["force"]/20 )
				damage += damage / 4; 

			// 
			// Inflict the damage and make armor effect.
			//
			defense_factor = your["combat_exp"];
			while( random(defense_factor) > my["combat_exp"] ) {
				damage -= damage / 3;
				defense_factor /= 2;
			}

			damage = victim->receive_damage("kee", damage, me );
			if( me->is_killing(victim)
			||	(weapon && random(damage) > (int)victim->query_temp("apply/armor")) ) {
				victim->receive_wound("kee",
					damage - (int)victim->query_temp("apply/armor"),
					me);
				wounded = 1;
			}

			result += damage_msg(damage, action["damage_type"]);
		
			// Gain combat_exp.
			if( ap < dp && (!userp(me) || !userp(victim))
			&&	random(my["gin"]*100/my["max_gin"] + my["int"]) > 30 ) {
				my["combat_exp"] += 1;
			if( my["potential"] - my["learned_points"] < 100 )
					my["potential"] += 1;
				me->improve_skill(attack_skill, 1);
			}
			if( (!userp(me) || !userp(victim))
			&&	random(your["max_kee"] + your["kee"]) < damage ) {
				your["combat_exp"] += 1;
				if( your["potential"] - your["learned_points"] < 100 )
					your["potential"] += 1;
			}
		}
	} 

	result = replace_string( result, "$l", limb );
	if( objectp(weapon) )
		result = replace_string( result, "$w", weapon->name() );

	message_vision(result, me, victim );

	if( damage > 0 ) {
		report_status(victim, wounded);
		if( victim->is_busy() ) victim->interrupt_me(me);
	}

	if( functionp(action["post_action"]) )
		evaluate( action["post_action"], me, victim, weapon, damage);

	// See if the victim can make a riposte.
	if( attack_type==TYPE_REGULAR
	&&	damage < 1
	&&	victim->query_temp("guarding") ) {
		victim->set_temp("guarding", 0);
		if( random(my["cps"]) < 5 ) {
			message_vision("$N@MSXF}T\n", me);
			do_attack(victim, me, victim->query_temp("weapon"), TYPE_QUICK);
		} else {
			message_vision("$N$n~MXoʧT\n", victim, me);
			do_attack(victim, me, victim->query_temp("weapon"), TYPE_RIPOSTE);
		}
	}
}

//	fight()
//
//	This is called in the attack() defined in F_ATTACK, which handles fighting
//	in the heart_beat() of all livings. Be sure to optimize it carefully.
//
void fight(object me, object victim)
{
	object ob;

	if( !living(me) ) return;

	// If victim is busy or unconcious, always take the chance to make an attack.
	if( victim->is_busy() || !living(victim) ) {
		me->set_temp("guarding", 0);
		do_attack(me, victim, me->query_temp("weapon"), TYPE_QUICK);

	// Else, see if we are brave enough to make an aggressive action.
	} else if( random( (int)victim->query("cps") * 3 ) < ((int)me->query("cor") + (int)me->query("bellicosity") / 50) ) {
		me->set_temp("guarding", 0);
		do_attack(me, victim, me->query_temp("weapon"), TYPE_REGULAR);

	// Else, we just start guarding.
	} else if( !me->query_temp("guarding") ) {
		me->set_temp("guarding", 1);
		message_vision( guard_msg[random(sizeof(guard_msg))], me, victim);
		return;
	} else return;

	// Make sure the victim had noticed the attack.
	if( !victim->is_fighting(me) ) victim->fight_ob(me);
}

//	auto_fight()
//
//	This function is to start an automatically fight. Currently this is
//	used in "aggressive", "vendetta", "hatred", "berserk" fight.
//
void auto_fight(object me, object obj, string type)
{
	// Don't let NPC autofight NPC.
	if( !userp(me) && !userp(obj) ) return;

	// Because most of the cases that we cannot start a fight cannot be checked
	// before we really call the kill_ob(), so we just make sure we have no 
	// aggressive callout wating here.
	if( me->query_temp("looking_for_trouble") ) return;
	me->set_temp("looking_for_trouble", 1);

	// This call_out gives victim a chance to slip trough the fierce guys.
	if( this_player(1)==obj ) call_out( "start_" + type, 0, me, obj);
	else call_other( this_object(), "start_" + type, me, obj);
}

void start_berserk(object me, object obj)
{
	int bellicosity;

	if( !me || !obj ) return;				// Are we still exist( not becoming a corpse )?

	me->set_temp("looking_for_trouble", 0);

	if(	me->is_fighting(obj)				// Are we busy fighting?
	||	!living(me)							// Are we capable for a fight?
	||	environment(me)!=environment(obj)	// Are we still in the same room?
	||	environment(me)->query("no_fight") 	// Are we in a peace room?
	)	return;

	bellicosity = (int)me->query("bellicosity");
	message_vision("$NΤ@ز˪ۦbC@ӤHC\n", me);

	if(	(int)me->query("force") > (random(bellicosity) + bellicosity)/2 ) return;

	if( bellicosity > (int)me->query("score") 
	&&	!wizardp(obj) ) {
		message_vision("$N$nܹDR" + RANK_D->query_self_rude(me)
			+ "ݧAbܤMhaC\n", me, obj);
		me->kill_ob(obj);
	} else {
		message_vision("$N$nܹDRޡT" + RANK_D->query_rude(obj)
			+ "M" + RANK_D->query_self_rude(me) + "QH[MڪaT\n",
			me, obj);
		me->fight_ob(obj);
	}
}

void start_hatred(object me, object obj)
{
	if( !me || !obj ) return;				// Are we still exist( not becoming a corpse )?

	me->set_temp("looking_for_trouble", 0);

	if(	me->is_fighting(obj)				// Are we busy fighting?
	||	!living(me)							// Are we capable for a fight?
	||	environment(me)!=environment(obj)	// Are we still in the same room?
	||	environment(me)->query("no_fight") 	// Are we in a peace room?
	)	return;

	// We found our hatred! Charge!
	message_vision( catch_hunt_msg[random(sizeof(catch_hunt_msg))], me, obj);
	me->kill_ob(obj);
}

void start_vendetta(object me, object obj)
{
	if( !me || !obj ) return;				// Are we still exist( not becoming a corpse )?

	me->set_temp("looking_for_trouble", 0);

	if(	me->is_fighting(obj)				// Are we busy fighting?
	||	!living(me)							// Are we capable for a fight?
	||	environment(me)!=environment(obj)	// Are we still in the same room?
	||	environment(me)->query("no_fight") 	// Are we in a peace room?
	)	return;

	// We found our vendetta opponent! Charge!
	me->kill_ob(obj);
}

void start_aggressive(object me, object obj)
{
	if( !me || !obj ) return;				// Are we still exist( not becoming a corpse )?

	me->set_temp("looking_for_trouble", 0);

	if(	me->is_fighting(obj)				// Are we busy fighting?
	||	!living(me)							// Are we capable for a fight?
	||	environment(me)!=environment(obj)	// Are we still in the same room?
	||	environment(me)->query("no_fight") 	// Are we in a peace room?
	)	return;

	// We got a nice victim! Kill him/her/it!!!
	me->kill_ob(obj);
}

// This function is to announce the special events of the combat.
// This should be moved to another daemon in the future.
void announce(object ob, string event)
{
	switch(event) {
		case "dead":
			message_vision("\n$NFC\n\n", ob);
			break;
		case "unconcious":
			message_vision("\n$N}U@ӤíM^baW@ʤ]ʤFC\n\n", ob);
			break;
		case "revive":
			message_vision("\n$NCCC}MMFLӡC\n\n", ob);
			break;
	}
}

void winner_reward(object killer, object victim)
{
	killer->defeated_enemy(victim);
}

void killer_reward(object killer, object victim)
{
	int bls;
	string vmark;

	// Call the mudlib killer apply.
	killer->killed_enemy(victim);

	if( userp(victim) ) {
		killer->add("PKS", 1);
		// Give the death penalty to the dying user.
		victim->set("bellicosity", 0);
		victim->add("combat_exp", -(int)victim->query("combat_exp") / 10);
		victim->delete("vendetta");
		if( (int)victim->query("potential") > (int)victim->query("learned_points"))
			victim->add("potential",
				((int)victim->query("learned_points") - (int)victim->query("potential"))/2 );
		victim->skill_death_penalty();

		bls = 10;
		CHANNEL_D->do_channel(this_object(), "rumor",
			sprintf("%sQ%sFC", victim->name(1), killer->name(1)));
	} else {
		killer->add("MKS", 1);
		bls = 1;
	}

	// NPC got 10 times of bellicosity than user.
	killer->add("bellicosity", bls * (userp(killer)? 1: 10));

	if( stringp(vmark = victim->query("vendetta_mark")) )
		killer->add("vendetta/" + vmark, 1);
}
