// fingerd.c

#include <net/dns.h>

void create() { seteuid( getuid() ); }

string age_string(int time)
{
	int month, day, hour;

	time /= 3600;
	hour = time % 24;
	time /= 24;
	day = time % 30;
	month = time / 30;
	return (month?month + "m":"") + (day?day + "d":"") + hour + "h";
}

string finger_all()
{
	object *ob;
	string msg;
	int i;

	ob = users();
	msg = "";
	for(i=0; i<sizeof(ob); i++)
		msg = sprintf("%s%-20s  %-20s  %-10s %s\n",
			msg, ob[i]->query("name"), ob[i]->query("id"),
			age_string( (int)ob[i]->query("mud_age")), query_ip_name(ob[i]) );
	return msg;
}

string finger_user(string name)
{
	object ob, body;
	string msg, mud;

	if( sscanf(name, "%s@%s", name, mud)==2 ) {
		GFINGER_Q->send_finger_q(mud, name, this_player(1));
		return "OǰeL{iݭn@ǮɶMеyԡC\n";
	}

	ob = new(LOGIN_OB);
	ob->set("id", name);
	if( !ob->restore() ) return "SoӪaC\n";
	msg =  sprintf("\n^NR\t%s\nm    WR\t%s\nvšR\t%s\n"
		"qlla}R\t%s\nWsua}R\t%s( %s )\n\n",
		ob->query("id"),
		ob->query("name"),
		SECURITY_D->get_status(name),
		ob->query("email"),
		ob->query("last_from"),
		ctime(ob->query("last_on"))
	);
	if( objectp(body = find_player(name)) ) {
		msg += sprintf("\n%sثebq %s suC\n", body->name(1),
			query_ip_name(body));
	}
	destruct(ob);
	return msg;
}

varargs string remote_finger_user(string name, int chinese_flag)
{
	object ob, body;
	string msg;

	ob = new(LOGIN_OB);
	ob->set("id", name);
	if( !ob->restore() )
		return chinese_flag ? "SoӪaC\n" : "No such user.\n";
	if( chinese_flag ) msg =  sprintf(
		"\n^NR\t%s\nm    WR\t%s\nvšR\t%s\n"
		"qlla}R\t%s\nWsua}R\t%s( %s )\n\n",
		ob->query("id"),
		ob->query("name"),
		SECURITY_D->get_status(name),
		ob->query("email"),
		ob->query("last_from"),
		ctime(ob->query("last_on"))
	);
	else msg =  sprintf(
		"\nName\t: %s\nStatus\t: %s\nEmail\t: %s\nLastOn\t: %s( %s )\n\n",
		capitalize(ob->query("id")),
		SECURITY_D->get_status(name),
		ob->query("email"),
		ob->query("last_from"),
		ctime(ob->query("last_on"))
	);
	if( find_player(name) )
		msg += chinese_flag ?
			("\n" + ob->query("name") + "ثebuWC\n"):
			("\n" + capitalize(name) + " is currently connected.\n");

	destruct(ob);
	return msg;
}

