// enable.c

#include <ansi.h>

inherit F_CLEAN_UP;

mapping valid_types = ([
	"unarmed":	"}",
	"sword":	"Ck",
	"blade":	"Mk",
	"stick":	"Ҫk",
	"throwing":	"t",
	"force":	"\\",
	"parry":	"۬[",
	"dodge":	"\\",
	"magic":	"kN",
	"spells":	"G",
	"move":		"",
	"array":	"}k",
]);

int main(object me, string arg)
{
	mapping map;
	string *types, *skill, ski, map_to;
	int i, modify;

	seteuid(getuid());

	if( !arg ) {
		map = me->query_skill_map();
		if( !mapp(map) || sizeof(map)==0 )
			return notify_fail("A{bSϥΥSޯC\n");

		skill = keys(valid_types);
		write("HUOAثeϥΤSޯC\n");
		for (i=0; i<sizeof(skill); i++) {
			if( undefinedp(valid_types[skill[i]]) ) {
				map_delete(map, skill[i]);
				continue;
			}
			if( !me->query_skill(skill[i]) ) continue;
			modify = me->query_temp("apply/" + skill[i]);
			printf("  %-20sR %-20s  ĵšR%s%3d\n" NOR, 
				valid_types[skill[i]] + " (" + skill[i] + ")",
				undefinedp(map[skill[i]]) ? "L" : to_chinese(map[skill[i]]),
				(modify==0 ? "" : (modify>0 ? HIC : HIR)),
				me->query_skill(skill[i]));
		}
		return 1;
	}

	if( arg=="?" ) {
		write("HUOiHϥίSޯ઺R\n");
		skill = sort_array(keys(valid_types), (: strcmp :) );
		for(i=0; i<sizeof(skill); i++) {
			printf("  %s (%s)\n", valid_types[skill[i]], skill[i] );
		}
		return 1;
	}

	if( sscanf(arg, "%s %s", ski, map_to)!=2 )
		return notify_fail("O榡Renable [<ޯ> <ޯW>|none]\n");

	if( undefinedp(valid_types[ski]) )
		return notify_fail("SoӧޯM enable ? iHdݦǺC\n");

	if( map_to=="none" ) {
		me->map_skill(ski);
		me->reset_action();
		write("Ok.\n");
		return 1;
	} else if( map_to==ski ) {
		write("u" + to_chinese(ski) + "vOҦ" + valid_types[ski] + "¦Mݭn enableC\n");
		return 1;
	}

	if( !me->query_skill(map_to, 1) )
		return notify_fail("A|oاޯC\n");

//	if( !me->query_skill(ski, 1) )
//		return notify_fail("Asu" + to_chinese(ski) + "vSǷ|MO"
//			+ to_chinese(map_to) + "FC\n");

	if( !SKILL_D(map_to)->valid_skill_usage(ski) )
		return notify_fail("oӧޯणoإγ~C\n");

	me->map_skill(ski, map_to);
	me->reset_action();
	write("Ok.\n");
	
	if( ski=="magic" ) {
		write("AΥt@تkNtMFOsC\n");
		me->set("atman", 0);
		me->receive_damage("gin", 0);
	} else if( ski=="force" ) {
		write("AΥt@ؤ\\MOsC\n");
		me->set("force", 0);
		me->receive_damage("kee", 0);
	} else if( ski=="spells" ) {
		write("AΥt@ةGtMkOs׷ҡC\n");
		me->set("mana", 0);
		me->receive_damage("sen", 0);
	}

	return 1;
}
int help(object me)
{
        write(@HELP
O榡 : enable [<ޯ> <ޯW> | none]
           enable ?

oӫOAwҭnΪޯMݫޯMޯW١CpG[
ƫh|ܥXޯΧAثeҨϥΪޯW MpG[@ ? |CX
ҦϥίSޯ઺ޯC
 
HELP
        );
        return 1;
}
