// go.c

inherit F_CLEAN_UP;

mapping default_dirs = ([
	"north":		"_",
	"south":		"n",
	"east":			"F",
	"west":			"",
	"northup":		"_",
	"southup":		"n",
	"eastup":		"F",
	"westup":		"",
	"northdown":	"_",
	"southdown":	"n",
	"eastdown":		"F",
	"westdown":		"",
	"northeast":	"F_",
	"northwest":	"_",
	"southeast":	"Fn",
	"southwest":	"n",
	"up":			"W",
	"down":			"U",
	"out":			"~",
]);

void create() { seteuid(getuid()); }

int main(object me, string arg)
{
	string dest, mout, min, dir;
	object env, obj;
	mapping exit;

	if( !arg ) return notify_fail("AnӤVS\n");

	if( me->over_encumbranced() )
		return notify_fail("AtLMʼuoC\n");

	if( me->is_busy() )
		return notify_fail("Aʧ@٨SMಾʡC\n");

	env = environment(me);
	if(!env) return notify_fail("A̤]hFC\n");

	if( !mapp(exit = env->query("exits")) || undefinedp(exit[arg]) ) {
		if( query_verb()=="go")
			return notify_fail("oӤVSXC\n");
		else
			return 0;
	}

	dest = exit[arg];

	if( !(obj = find_object(dest)) )
		call_other(dest, "???");
	if( !(obj = find_object(dest)) )
		return notify_fail("LkʡC\n");

	if( !env->valid_leave(me, arg) ) return 0;

	if( !undefinedp(default_dirs[arg]) )
		dir = default_dirs[arg];
	else
		dir = arg;

	if( me->is_fighting() ) {
		mout = "" + dir + "ӰkFC\n";
		min = "^^a]FLӡMҼ˦ǯTVC\n";
	} else {
		mout = "" + dir + "}C\n";
		min = "FLӡC\n";
	}

	message( "vision", me->name() + mout, environment(me), ({me}) );
	if( me->move(obj) ) {
		me->remove_all_enemy();
		message( "vision", me->name() + min, environment(me), ({me}) );
		me->set_temp("pending", 0);
		all_inventory(env)->follow_me(me, arg);
		return 1;
	}

	return 0;
}

void do_flee(object me)
{
	mapping exits;
	string *directions;

	if( !environment(me) ) return;
	exits = environment(me)->query("exits");
	if( !mapp(exits) || !sizeof(exits) ) return;
	directions = keys(exits);
	tell_object(me, "ݨӸӧ|k]F...\n");
	main(me, directions[random(sizeof(directions))]);
}

int help(object me)
{
	write(@HELP
O榡 : go <V>
 
AwVʡC
 
HELP
    );
    return 1;
}
