// recruit.c

#include <ansi.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	object ob, old_rec;
	mapping family;
	int i;

	if( !arg ) return notify_fail("O榡Rrecruit [cancel]|<H>\n");

	if( arg=="cancel" ) {
		old_rec = me->query_temp("pending/recruit");
		if( !objectp(old_rec) )
			return notify_fail("A{bèSH̤lNC\n");
		write("AܥDNQ" + old_rec->name() + "̤lFC\n");
		tell_object(old_rec, me->name() + "ܥDNQA̤lFC\n");
		me->delete_temp("pending/recruit");
		return 1;
	}

	if( !(ob = present(arg, environment(me))) )
		return notify_fail("AQ֧@̤lS\n");

	if( ob==me ) return notify_fail("ۤv̤lSnDN....LSΡC\n");

	if( ob->is_apprentice_of(me) ) {
		message_vision("$N$nYMDRun{Tv\n", me, ob);
		return 1;
	}

	if( !me->query("family") )
		return notify_fail("AäݩMA[J@ӪMΦۤvФ@Ӥ~ব{C\n");

	// If the target is willing to apprentice us already, we do it.
	if( (object)ob->query_temp("pending/apprentice") == me ) {

		if( !living(ob) ) {
			message_vision(
				"$NMw$n̤lC\n\n"
				"Lݼˤl$nMSkv§C\n\n",
				me, ob);
			return 1;
		}

		if( ob->query("family") ) {
			mapping skills;
			string *skname;
			
			message_vision(
				"$NMwIqvMJ$nUTT\n\n"
				"$NFUӦV$nqqaWF|TYMsDRuvTv\n\n",
				ob, me);
			ob->set("score", 0);
			skills = ob->query_skills();
			if( mapp(skills) ) {
				skname = keys(skills);
				for(i=0; i<sizeof(skname); i++) {
					skills[skname[i]] /= 2;
					if( !skills[skname[i]] )
						ob->delete_skill(skname[i]);
				}
			}
ob->set("max_atman", (int)ob->query("max_atman")/2);
ob->set("max_force", (int)ob->query("max_force")/2);
ob->set("max_mana", (int)ob->query("max_mana")/2);
			tell_object(ob, "AFsvܩۡM@ohbƱqeҾǡC\n\n");
		} else
			message_vision(
				"$NMw$n̤lC\n\n"
				"$nFUӦV$NqqaWF|TYMsDRuvTv\n",
				me, ob);

		me->recruit_apprentice(ob);
		ob->delete_temp("pending/apprentice");

		write("ߧAsF@W̤lT\n");
		family = ob->query("family");
		tell_object( ob, sprintf("߱z%s%sN̤lC\n", family["family_name"],
			chinese_number(family["generation"]) ));

		return 1;
	

	} else {

		old_rec = me->query_temp("pending/recruit");
		if( ob==old_rec )
			return notify_fail("AQ" + ob->name() + "̤lMO٨SC\n");
		else if( objectp(old_rec) ) {
			write("AܥDNQ" + old_rec->name() + "̤lFC\n");
			tell_object(old_rec, me->name() + "ܥDNQA̤lFC\n");
		}

		me->set_temp("pending/recruit", ob );
		message_vision("\n$NQn$n̤lC\n", me, ob);
		tell_object(ob, YEL "pGA@N" + me->name() + "vM apprentice OC\n" NOR);
		return 1;
	}
}


int help(object me)
{
        write(@HELP
O榡 : recruit [cancel]|<H>
 
oӫOAYH̤l, pG]nAv.
 
HELP
        );
        return 1;
}
