// skills.c

#include <ansi.h>

inherit F_CLEAN_UP;

string *skill_level_desc = ({
	BLU "ǥEm" NOR,
	HIB "ʳq֤" NOR,
	HIB "bͤ" NOR,
	HIB "" NOR,
	HIB "rN" NOR,
	CYN "X޵" NOR,
	CYN "G" NOR,
	CYN "XJ" NOR,
	HIC "npy" NOR,
	HIC "@Nvv" NOR,
	HIW "`i" NOR
});

string *knowledge_level_desc = ({
	BLU "sǥE" NOR,
	HIB "s|" NOR,
	HIB "@G" NOR,
	HIB "" NOR,
	HIB "wp" NOR,
	CYN "߻⯫|" NOR,
	CYN "FM" NOR,
	CYN "ŵMeq" NOR,
	HIC "|@L" NOR,
	HIC "_jव" NOR,
	HIW "`i" NOR
});

string skill_level(string, int);

int main(object me, string arg)
{
	object ob;
	mapping skl, lrn, map;
	string *sname, *mapped;
	int i;

	seteuid(getuid());

	if(!arg)
		ob = me;
	else {
		ob = present(arg, environment(me));
		if (!ob) ob = find_player(arg);
		if (!ob) ob = find_living(arg);
		if (!ob) return notify_fail("Anݽ֪ޯS\n");
	}

	if( ob!=me && !wizardp(me) && !ob->is_apprentice_of(me)
	&& !me->is_apprentice_of(ob) )
		return notify_fail("uŮvΦv{YHݥLHޯC\n");

	skl = ob->query_skills();
	if(!sizeof(skl)) {
		write( (ob==me ? "A" : ob->name()) + "ثeèSǷ|ޯC\n");
		return 1;
	}
	write( (ob==me ? "A" : ob->name()) +"ثeҾǹLޯR\n\n");
	sname  = sort_array( keys(skl), (: strcmp :) );
	
	map = ob->query_skill_map();
	if( mapp(map) ) mapped = values(map);
	if( !mapped ) mapped = ({});

	lrn = ob->query_learned();
	if( !mapp(lrn) ) lrn = ([]);
	
	for(i=0; i<sizeof(skl); i++) {
		printf("%s%s%-40s" NOR " - %-10s %3d/%5d\n", 
			(lrn[sname[i]] >= (skl[sname[i]]+1) * (skl[sname[i]]+1)) ? HIM : "",
			(member_array(sname[i], mapped)==-1? "  ": ""),
			to_chinese(sname[i]) + " (" + sname[i] + ")",
			skill_level(SKILL_D(sname[i])->type(), skl[sname[i]]),
			skl[sname[i]], (int)lrn[sname[i]],
		);
	}
	write("\n");
	return 1;
}

string skill_level(string type, int level)
{
	int grade;

	grade = level / 10;

	switch(type) {
		case "knowledge":
			return knowledge_level_desc[grade];
		default:
			return skill_level_desc[grade];
	}
}

int help(object me)
{
	write(@HELP
O榡 : skills [<YH>]

oӫOiHA(p)dߩҾǹLޯC

A]iHw@өMAv{YHM skills iHd誺ޯબpC

ŮviHdߥH NPC ޯબpC

HELP
    );
    return 1;
}
