// haunt.c

#include <ansi.h>

inherit F_CLEAN_UP;

int scribe(object me, object sheet, string arg)
{
	if( me->is_fighting() )	return notify_fail("Ab԰T\n");
	
	if( (int)me->query("mana") < 20 ) return notify_fail("AkOFT\n");

	if( !arg ) return notify_fail("AnboiŤWg֪WrS\n");

	sheet->set_name(YEL "LͰl" NOR, ({ "haunting sheet", "sheet"}) );	
	sheet->set("attach_func", (: call_other, __FILE__, "do_haunt", arg :) );
	me->add("mana", -20);
	me->receive_damage("sen", 10);

	return 1;
}

int do_haunt(string target, object who)
{
	object dest;

	if( !who->is_zombie() )
		return notify_fail(YEL "LͰl" NOR "uΦbLͨWC\n");

	if( !who->query("possessed") )
		return notify_fail("AΪkO" + who->name() + "~ϥγoDšC\n");

	dest = present(target, environment(who));
	if( !dest ) dest = find_player(target);
	if( !dest ) dest = find_living(target);
	if( objectp(dest) ) {
		who->kill_ob(dest);
		who->set_leader(dest);
		message_vision("$NMC}MaDR" RED "........$n....\n" NOR,
			who, dest);
		if( environment(dest)==environment(who) ) {
			dest->fight_ob(who);
		}
	} else {
		message_vision("$NMC}MaDR" RED "............\n" NOR,
			who);
		if( this_player() ) {
			who->kill_ob(this_player());
			who->set_leader(this_player());
			this_player()->fight_ob(who);
		}
	}
	return 1;
}
