// inn.c

#include <room.h>

inherit ROOM;

string look_sign(object me);

void create()
{
	set("short", "ȴ");
	set("long", @LONG
A{bbFn䪺@apȴ̸̡MoaȴpMoO
ʨ̭tW@aMȴ̪DHڻO@춳C|PHMpG
Aֽt`pܡM]\iHbo̹JLC~MӦۦUaȤH
wEbo̥洫ȳ~WDMA]iHbo̥ť\h쪺
Cafa観@QJ۵P(sign)C
    _䦳@Ӭ(door)MWxۤ@hզ⪺wM@إOHP
ıܦOqMSܬXM~C
LONG
	);

	// This enables players to save this room as their startroom.
	set("valid_startroom", 1);

	set("item_desc", ([
		"sign": (: look_sign :),
		"door": (: look_door, "northwest" :),
	]) );
	
	set("exits", ([
		"east"    	: "/d/snow/square",
		"up"		: "/d/snow/inn_2f",
		"northwest"	: "/d/wiz/entrance" ]) );

	set("objects", ([
//		"/d/npc/sungoku" : 1,
		"/d/snow/npc/waiter" : 1 ]) );

	create_door("northwest", "", "southeast", DOOR_CLOSED);

	setup();

	// To "load" the board, don't ever "clone" a bulletin board.
	call_other( "/obj/board/common_b", "???" );
}

string look_sign(object me)
{
	if( wizardp(me) )
		return "۵PgۡRȴ̡C@ƤprRDC\n";
	else
		return "۵PgۡRȴ̡C\n";
}
