#include <login.h>

inherit F_DBASE;
inherit F_SAVE;

void logon()
{
	call_out( "time_out", LOGIN_TIMEOUT );
	LOGIN_D->logon( this_object() );
}

// Don't destruct(this_object()) in the net_dead() interactive apply or
// there'll be error message: Double call to remove_interactive()
void net_dead()
{
	remove_call_out("time_out");
	call_out( "time_out", 1 );
}

void time_out()
{
	if( objectp(query_temp("body_ob")) ) return;
	if( interactive(this_object()) )
		write("zbsuiJ򪺮ɶӤ[FMUQnAӧaC\n");
	destruct(this_object());
}

// This is used by F_SAVE to determinethe file name to save our data.
string query_save_file()
{
	string id;

	id = query("id");
	if( !stringp(id) ) return 0;
	return DATA_DIR + "login/" + id[0..0] + "/" + id;
}

void receive_message(string type, string str)
{
	if( type!= "write" ) return;
	receive(str);
}

void terminal_type(string term_type)
{
	set_temp("terminal_type", term_type);
}
