// token.c

inherit ITEM;
inherit F_AUTOLOAD;
inherit F_SAVE;

void create()
{
	set_name("SH", ({ "token" }) );
	set("unit", "");
	set("leader_title", "xH");
	seteuid(getuid());
}

string short()
{
	string guild;

	if( stringp(query("short")) || !stringp(guild = query("guild_name")) )
		return ::short();
	else
		return guild + ::short();
}

string long()
{
	if( stringp(query("long")) )
		return ::long();
	else if ( stringp(query("guild_id"))) return @TEXT
oO@ӤwgѶ}ʦLSHMAiHΥHUOӳгyݩAۤv
|´R

    modify <> <r>    קH~[BWٵ
    assign                  N´SmǵOH
    dismiss                 ä[ѴoӲ´
    
TEXT
	;
	else return @TEXT
oO@ӥΨaإߪB|ɩҥΪSHMo~HNO
oӲ´S(xH)MS㦳۶ҷsB}즳BHΧ令
ٸvOMoH|۰xsMbإߤ@Ӫe@WŮvѰ
H۪ʦL(unseal)C
TEXT
	;
}

void init()
{
	if( !environment()->is_character() ) {
		message_vision("$NoX@}ģ~MMFC\n", this_object());
		destruct(this_object());
	} else {
		add_action("do_unseal", "unseal");
		add_action("do_assign", "assign");
		add_action("do_modify", "modify");
		add_action("do_dismiss", "dismiss");
	}
}

string query_autoload() { return query("guild_id"); }

string query_save_file() { return DATA_DIR + "guild/" + query("guild_id"); }

void autoload(string name)
{
	if( !restore() ) {
		if( environment() ) environment()->delete("family");
		destruct(this_object());
	}
}

int do_unseal(string arg)
{
	int i;
	string guild_id, guild_name;

	if( query("guild_id") )
		return notify_fail( query("name") + "ʦLwgQѶ}FC\n");

	if( !wizardp(this_player(1)) )
		return notify_fail(
			"uŮvѰSHʦLMpGAnХߤ@ӷs|M\n"
			"@ŮvOHMХL(o)AѰʦLC\n");

	if(!arg) 
		return notify_fail("O榡Runseal <N> <W>\n");

	if( sscanf(arg, "%s %s", guild_id, guild_name)!= 2 ) {
		set("guild_id", arg);
		if( restore() ) {
			write("Ok.\n");
			return 1;
		} else {
			delete("guild_id");
			return notify_fail("SoӪC\n");
		}
	}

	for(i=0; i<strlen(guild_id); i++)
		if( guild_id[i] < 'a' || guild_id[i] > 'z' )
			return notify_fail("<N>Ѥpg^rզC\n");

	set("guild_id", guild_id);
	set("guild_name", guild_name);

	if(file_size(query_save_file() + SAVE_EXTENSION)>=0	)
		restore();
	else {
		log_file("UNSEAL", sprintf("%s [%s] by %s, %s\n",
			guild_name, guild_id, this_player(1)->query("id"), ctime(time()) ));
	}

	write("Ok.\n");
	return 1;
}

int do_assign(string arg)
{
	object ob;
	mapping family;
	string assign_msg;

	if( !arg || !objectp(ob = present(arg, environment(this_player())))
	|| !living(ob) ) 
		return notify_fail("AnNxHǵ֡S\n");

	family = this_player(1)->query("family");

	if( wizardp(this_player(1)) || (
		mapp(family) && family["family_name"]==(string)query("guild_name")
		&& (string)this_player(1)->query("id")==(string)query("leader"))	) {
		// If this is a new guild, create its family.
		if( !query("leader") )
			ob->create_family(query("guild_name"));
		else {
			family = ob->query("family");
			if( !mapp(family) || (family["family_name"]!=(string)query("guild_name")) )
				return notify_fail( ob->query("name") + "äO" + query("guild_name") + "@lC\n");
		}
		ob->assign_apprentice( query("leader_title"), -1 );
		set("leader", ob->query("id"));
		if( stringp(assign_msg = query("assign_msg")) )
			message_vision( assign_msg, this_player(1), ob);
		else
			message_vision(
				"\n$NN" + query("guild_name") + "" + query("name") + "浹F$nC\n"
				"\n$pNO" + query("guild_name") + "xHFC\n\n", this_player(1), ob);
		move(ob);
		write("Ok.\n");
		return 1;
	} else
		return notify_fail("ASovOC\n");
}

int do_modify(string arg)
{
	string prop, str;

	if( !query("guild_id") ) return 0;
	
	if( !arg || sscanf(arg, "%s %s", prop, str)!=2 )
		return notify_fail("O榡Rmodify <> <T>\n");
	switch(prop) {
		case "name":
		case "long":
		case "short":
		case "assign_msg":
		case "leader_title":
			set(prop, str);
			save();
			write("Ok.\n");
			break;
		default:
			write("Aק諸إuRname, short, long, assign_msg, leader_titleC\n");
	}
	return 1;
}

int do_dismiss(string arg)
{
	if( !query("guild_id") ) return 0;

	rm(query_save_file() + SAVE_EXTENSION);
	write( query("guild_name") + "QѴFC\n");
	destruct(this_object());
	return 1;
}
