// bank.c

inherit ROOM;

void init()
{
	add_action("do_convert", "convert");
}

int do_convert(string arg)
{
	string from, to;
	int amount, bv1, bv2;
	object from_ob, to_ob;

	if( !arg || sscanf(arg, "%d %s to %s", amount, from, to)!=3 )
		return notify_fail("O榡Rconvert <ƶq> <f> to <f>\n");

	from_ob = present(from + "_money", this_player());
	to_ob = present(to + "_money", this_player());
	if( !to_ob && file_size("/obj/money/" + to + ".c") < 0 )
		return notify_fail("AQI@ؿS\n");

	if( !from_ob )		return notify_fail("AWSoسfC\n");
	if( amount < 1 )	return notify_fail("If@ܤ֭nI@ӡC\n");
		
	if( (int)from_ob->query_amount() < amount )
		return notify_fail("AWSh" + from_ob->query("name") + "C\n");

	bv1 = from_ob->query("base_value");
	if( !bv1 ) return notify_fail("oتF褣ȿC\n");

	bv2 = to_ob ? to_ob->query("base_value") : call_other("/obj/money/" + to, "query", "base_value" );

	if( bv1 < bv2 ) amount -= amount % (bv2 / bv1);
	if( amount==0 )	return notify_fail("o" + from_ob->query("name") + "ȤӧCFM_C\n");

	if( !to_ob ) {
		to_ob = new("/obj/money/" + to);
		to_ob->move(this_player());
		to_ob->set_amount(amount * bv1 / bv2);
	} else
		to_ob->add_amount(amount * bv1 / bv2);

	message_vision( sprintf("$NqWX%s%s%sM%s%s%sC\n",
		chinese_number(amount), from_ob->query("base_unit"), from_ob->query("name"),
		chinese_number(amount * bv1 / bv2), to_ob->query("base_unit"), to_ob->query("name")),
		this_player() );

	from_ob->add_amount(-amount);

	return 1;
}
