// hockshop.c

inherit ROOM;

void init()
{
	add_action("do_value", "value");
	add_action("do_pawn", "pawn");
	add_action("do_sell", "sell");
}

string value_string(int value)
{
	if( value < 1 ) value = 1;
	else if( value < 100 )
		return chinese_number(value) + "";
	else
		return chinese_number(value/100) + ""
			+ (value%100? "S" + chinese_number(value%100) + "": "");
}

void pay_player(object who, int amount)
{
	object ob;

	if( amount < 1 ) amount = 1;
	if( amount/100 ) {
		ob = new(SILVER_OB);
		ob->set_amount(amount/100);
		ob->move(who);
		amount %= 100;
	}
	if( amount ) {
		ob = new(COIN_OB);
		ob->set_amount(amount);
		ob->move(who);
	}
}

int do_value(string arg)
{
	object ob;
	int value;

	if( !arg || !(ob = present(arg, this_player())) )
		return notify_fail("An򪫫~QS\n");

	if( ob->query("money_id") )
		return notify_fail("oOuvMASLܡS\n");

	value = ob->query("value");
	if( !value ) printf("%s@夣ȡC\n", ob->query("name"));
	else 
		printf("%s%sC\npGAn(pawn)MiH%sΤ@iC\npG_(sell)MiH%sC\n",
			ob->query("name"), value_string(value),
			value_string(value * 60 / 100), value_string(value * 80 / 100));

	return 1;
}

int do_pawn(string arg)
{
	object ob;
	int value;

	if( !arg || !(ob = present(arg, this_player())) )
		return notify_fail("An򪫫~S\n");

	if( ob->query("money_id") )	return notify_fail("AnuvS\n");

	value = ob->query("value");
	if( !value ) return notify_fail("o˪F褣ȿC\n");

	message_vision("$N⨭W" + ob->query("name") + "XӨF"
		+ value_string(value * 60 / 100) + "C\n", this_player());

	pay_player(this_player(), value * 60 / 100);
	destruct(ob);

	return 1;
}

int do_sell(string arg)
{
	object ob;
	int value;

	if( !arg || !(ob = present(arg, this_player())) )
		return notify_fail("An_򪫫~S\n");

	if( ob->query("money_id") )	return notify_fail("AnuvS\n");
	value = ob->query("value");
	if( !value ) return notify_fail("o˪F褣ȿC\n");


	message_vision("$N⨭W" + ob->query("name") + "汼C\n",
		this_player());

	pay_player(this_player(), value * 80 / 100);
	destruct(ob);

	return 1;
}

