// logind.c

#include <ansi.h>
#include <command.h>
#include <login.h>

inherit F_DBASE;

string *banned_name = ({
	"A", "p", "", "L", "o", "e", "",
	"wuS",
});

int check_legal_id(string arg);
int check_legal_name(string arg);
void confirm_id(string yn, object ob);
object make_body(object ob);
varargs void enter_world(object ob, object user, int silent);
varargs void reconnect(object ob, object user, int silent);
object find_body(string name);

void create() 
{
	seteuid(getuid());
	set("channel_id", "suF");
}

void logon(object ob)
{
	object *usr;
	int i, wiz_cnt, ppl_cnt, login_cnt;

	cat(WELCOME);
	UPTIME_CMD->main();

	usr = users();
	wiz_cnt = 0;
	ppl_cnt = 0;
	login_cnt = 0;
	for(i=0; i<sizeof(usr); i++) {
		if( !environment(usr[i]) ) login_cnt++;
		else if( wizardp(usr[i]) ) wiz_cnt++;
		else ppl_cnt++;
	}
	printf("ثe@ %d ŮvB%d 쪱abuWMH %d ϥΪ̹ճsuC\n\n",
		wiz_cnt, ppl_cnt, login_cnt );

	write("z^WrR");
	input_to("get_id", ob);
}

void get_id(string arg, object ob)
{
	object ppl;

	arg = lower_case(arg);
	if( !check_legal_id(arg)) {
		write("z^WrR");
		input_to("get_id", ob);
		return;
	}

#ifdef MAX_USERS
	if( (string)SECURITY_D->get_status(arg)=="(player)"
	&& sizeof(users()) >= MAX_USERS ) {
		ppl = find_body(arg);
		// Only allow reconnect an interactive player when MAX_USERS exceeded.
		if( !ppl || !interactive(ppl) ) {
			write("藍_M" + MUD_NAME + "ϥΪ̤wgӦhFMЫݷ|AӡC\n");
			destruct(ob);
			return;
		}
	}
#endif
	
	ob->set("id", arg);
	if( ob->restore() ) {
		write("пJKXR");
		input_to("get_passwd", 1, ob);
		return;
	}

	write("ϥγoӦWrN|гy@ӷsHMzTw(y/n)S");
	input_to("confirm_id", ob);
}

void get_passwd(string pass, object ob)
{
	string my_pass;
	object user;

	write("\n");
	my_pass = ob->query("password");
	if( crypt(pass, my_pass) != my_pass ) {
		write("KX~T\n");
		destruct(ob);
		return;
	}

	// Check if we are already playing.
	user = find_body(ob->query("id"));
	if (user) {
		if( user->query_temp("netdead") ) {
			reconnect(ob, user);
			return;
		}
		write("znNt@ӳsuۦPHXhMӥNܡS(y/n)");
		input_to("confirm_relogin", ob, user);
		return;
	}

	if( objectp(user = make_body(ob)) ) {
		if( user->restore() ) {
			log_file( "USAGE", sprintf("%s loggined from %s (%s)\n", user->query("name"),
				query_ip_name(ob), ctime(time()) ) );
			enter_world(ob, user);
			return;
		} else {
			destruct(user);
		}
	}
	write("бzsгyoӤHC\n");
	confirm_id("y", ob);
}

void confirm_relogin(string yn, object ob, object user)
{
	object old_link;

	if( yn=="" ) {
		write("znNt@ӳsuۦPHXhMӥNܡS(y/n)");
		input_to("confirm_relogin", ob, user);
		return;
	}	

	if( yn=="DESTROY" ) {
		write("KOҰ....");
		// destruct(user);
		write("Ok.\n");
		user = make_body(ob);
	} else if( yn[0]!='y' && yn[0]!='Y' ) {
		write("naMwUAӡC\n");
		destruct(ob);
		return;
	} else {
		tell_object(user, "HqOB( " + query_ip_number(ob)
			+ " )suNAұHC\n");
		log_file( "USAGE", sprintf("%s replaced by %s (%s)\n", user->query("name"),
			query_ip_name(ob), ctime(time()) ) );
	}

	// Kick out tho old player.
	old_link = user->query_temp("link_ob");
	if( old_link ) {
		exec(old_link, user);
		destruct(old_link);
	}

	reconnect(ob, user);	
}

void confirm_id(string yn, object ob)
{
	if( yn=="" ) {
		write("ϥγoӦWrN|гy@ӷsHMzTw(y/n)S");
		input_to("confirm_id", ob);
		return;
	}	

	if( yn[0]!='y' && yn[0]!='Y' ) {
		write("naMЭsJz^WrR");
		input_to("get_id", ob);
		return;
	}

	write( @TEXT

бzQ@ӦMөʡMS|ө_ǪWrMSOnz
OM mud O@ӥHjPF謰I@ MФn@Ǥ
άOeyLHxZWrMoӦWrNNAHMӥB
NAMаȥVC
  ^^^^^^^^^^
(FWr~M mud \h︹BO٪]pMҥHGĳz
 @ӤWrWrC)
TEXT
	);
	write("zWrR");
	input_to("get_name", ob);
}

void get_name(string arg, object ob)
{
	if( !check_legal_name(arg) ) {
		write("zWrR");
		input_to("get_name", ob);
		return;
	}

	ob->set("name", arg);
	write("г]wzKXR");
	input_to("new_password", 1, ob);
}

void new_password(string pass, object ob)
{
	write("\n");
	if( strlen(pass)<5 ) {
		write("KXצܤ֭nӦrMЭ]zKXR");
		input_to("new_password", 1, ob);
		return;
	}
	ob->set("password", crypt(pass,0) );
	write("ЦAJ@zKXMHT{zSOR");
	input_to("confirm_password", 1, ob);
}

void confirm_password(string pass, object ob)
{
	string old_pass;
	write("\n");
	old_pass = ob->query("password");
	if( crypt(pass, old_pass)!=old_pass ) {
		write("z⦸JKXä@ˡMЭs]w@KXR");
		input_to("new_password", 1, ob);
		return;
	}

	write("zqlla}R");
	input_to("get_email",  ob);
}

void get_email(string email, object ob)
{
	object user;

	ob->set("email", email);

	// If you want do race stuff, ask player to choose one here, then you can
	// set the user's body after the question is answered. The following are
	// options for player's body, so we clone a body here.
	ob->set("body", USER_OB);
	if( !objectp(user = make_body(ob)) )
		return;

	write("zntk(m)Τk(f)S");
	input_to("get_gender", ob, user);
}

void get_gender(string gender, object ob, object user)
{
	if( gender=="" ) {
		write("zntk(m)Τk(f)S");
		input_to("get_gender", ob, user);
		return;
	}

	if( gender[0]=='m' || gender[0]=='M' )
		user->set("gender", "k");
	else if( gender[0]=='f' || gender[0]=='F' )
		user->set("gender", "k" );
	else {
		write("藍_Mzuܨk(m)Τk(f)R");
		input_to("get_gender", ob, user);
		return;
	}

	log_file( "USAGE", sprintf("%s was created from %s (%s)\n", user->query("id"),
		query_ip_name(ob), ctime(time()) ) );
	enter_world(ob, user);
}

object make_body(object ob)
{
	string err;
	object user;
	int n;

	user = new(ob->query("body"));
	if(!user) {
		write("{bi঳HbקϥΪ̪󪺵{MLkiƻsC\n");
		write(err+"\n");
		return 0;
	}
	seteuid(ob->query("id"));
	export_uid(user);
	export_uid(ob);
	seteuid(getuid());
	user->set("id", ob->query("id"));
	user->set_name( ob->query("name"), ({ ob->query("id")}) );
	user->set("title", "qʩm");
	user->set("birthday", time() );
	user->set("potential", 99);

	n = random(21);
	user->set("str", 30 - n);
	user->set("cps", 10 + n);

	n = random(21);
	user->set("int", 30 - n);
	user->set("cor", 10 + n);

	n = random(21);
	user->set("con", 30 - n);
	user->set("spi", 10 + n);

	n = random(21);
	user->set("per", 30 - n);
	user->set("kar", 10 + n);

	return user;
}

varargs void enter_world(object ob, object user, int silent)
{
	object cloth;
	string status, startroom;

	user->set_temp("link_ob", ob);
	ob->set_temp("body_ob", user);
	exec(user, ob);

	status = SECURITY_D->get_status(user);
	write("ثevR" + status + "\n");
	user->setup();

	// In case of new player, we save them here right aftre setup 
	// compeleted.
	user->save();
	ob->save();

	cloth = new("/obj/cloth");
	cloth->move(user);
	cloth->wear();

	if( !silent ) {
		cat(MOTD);
		if( ob->query("new_mail") ) {
			printf( BOLD + "\nltiDARuzHTv\n\n" + NOR);
			ob->set("new_mail", 0);
		}
		if( user->is_ghost() )
			startroom = DEATH_ROOM;
		else if( !stringp(startroom = user->query("startroom")) )
			startroom = START_ROOM;

		user->move(startroom);
		tell_room(startroom, user->query("name") + "suiJoӥ@ɡC\n",
			({user}));
	}
	CHANNEL_D->do_channel( this_object(), "sys",
		sprintf("%s%ssuiJC", user->name(), query_ip_name(user)) );
	UPDATE_D->check_user(user);
}

varargs void reconnect(object ob, object user, int silent)
{
	user->set_temp("link_ob", ob);
	ob->set_temp("body_ob", user);
	exec(user, ob);

	user->reconnect();
	if( !silent ) {
		tell_room(environment(user), user->query("name") + "ssu^oӥ@ɡC\n",
		({user}));
	}
	CHANNEL_D->do_channel( this_object(), "sys",
		sprintf("%s%sssuiJC", user->query("name"), query_ip_name(user)) );
	UPDATE_D->check_user(user);
}

int check_legal_id(string id)
{
	int i;

	i = strlen(id);
	
	if( (strlen(id) < 3) || (strlen(id) > 12 ) ) {
		write("藍_MA^WrO 3  12 ӭ^rC\n");
		return 0;
	}
	while(i--)
		if( id[i]<'a' || id[i]>'z' ) {
			write("藍_MA^Wruέ^rC\n");
			return 0;
		}

	return 1;
}

int check_legal_name(string name)
{
	int i;

	i = strlen(name);
	
	if( (strlen(name) < 2) || (strlen(name) > 12 ) ) {
		write("藍_MAWrO 1  6 ӤrC\n");
		return 0;
	}
	while(i--) {
		if( name[i]<=' ' ) {
			write("藍_MAWrαrC\n");
			return 0;
		}
		if( i%2==0 && !is_chinese(name[i..i+1]) ) {
			write("藍_MбzΡuvWrC\n");
			return 0;
		}
	}
	if( member_array(name, banned_name)!=-1 ) {
		write("藍_MoئWr|yLHxZC\n");
		return 0;
	}

	return 1;
}

object find_body(string name)
{
	object ob, *body;

	if( objectp(ob = find_player(name)) )
		return ob;
	body = children(USER_OB);
	for(int i=0; i<sizeof(body); i++)
		if( clonep(body[i])
		&&	getuid(body[i]) == name ) return body[i];

	return 0;
}

