// get.c

inherit F_CLEAN_UP;

int do_get(object me, object ob);

void create() { seteuid(getuid()); }

int main(object me, string arg)
{
	string from, item;
	object obj, *inv, env, obj2;
	int i, amount;

	if(!arg) return notify_fail("An߰_FS\n");

	if( sscanf(arg, "%s from %s", arg, from)==2 ) {
		env = present(from, me);
		if(!env) env = present(from, environment(me));
		if(!env || !env->is_container())
			return notify_fail("A䤣 " + from + " o˪FC\n");
	} else env = environment(me);

	if(sscanf(arg, "%d %s", amount, item)==2) {
		if( !objectp(obj = present(item, env)) )
			return notify_fail("ǫSo˪FC\n");
		if( !obj->query_amount() )
			return notify_fail( obj->name() + "Q}C\n");
		if( amount < 1 )
			return notify_fail("F誺ӼƦܤ֬O@ӡC\n");
		if( amount > obj->query_amount() )
			return notify_fail("ǫSh" + obj->name() + "C\n");
		else if( amount == (int)obj->query_amount() )
			return do_get(me, obj);
		else {
			obj->set_amount( (int)obj->query_amount() - amount );
			obj2 = new(base_name(obj));
			obj2->move(env);			// For containers.
			obj2->set_amount(amount);
			return do_get(me, obj2);
		}
	}

	if(arg=="all") {
		inv = all_inventory(env);
		if( !env->query_max_encumbrance() )
			return notify_fail("OeC\n");
		if( !sizeof(inv) )
			return notify_fail("̭SFC\n");
		for(i=0; i<sizeof(inv); i++) {
			if( inv[i]->is_character() || inv[i]->query("no_get") ) continue;
			do_get(me, inv[i]);
		}
		write("Ok.\n");
		return 1;
	}

	if( !objectp(obj = present(arg, env)) || living(obj) )
		return notify_fail("ASo˪FC\n");

	if( obj->query("no_get") )
		return notify_fail("oӪF讳_ӡC\n");
	
	return do_get(me, obj);
}
	
int do_get(object me, object obj)
{
	object old_env, *enemy;
	int to_save;

	old_env = environment(obj);

	if( obj->is_character() ) {
		//	if( !userp(obj) && !obj->is_corpse() )
		//		return notify_fail("AuItLaC\n");
		// If we try to save someone from combat, take the risk :P
		to_save = me->query("cor");
		enemy = all_inventory(old_env);
		for(int i=0; i<sizeof(enemy); i++)
			if( enemy[i]->is_killing(obj) ) {
				if( userp(enemy[i]) ) enemy[i]->fight_ob(me);
				else				  enemy[i]->kill_ob(me);
				me->fight_ob(enemy[i]); 
			}
	}

	if( obj->move(me) ) {
		if( obj->is_character() )
			message_vision( "$NN$nߤF_ӴbIWC\n", me, obj );
		else
			message_vision( sprintf("$N%s@%s$nC\n", 
				old_env==environment(me)? "߰_": (
				old_env->is_corpse()? "q" + old_env->name() + "W_": "q" + old_env->name() + "X"),
				obj->query("unit")), me, obj );
		return 1;
	}
	else return 0;
}

int help(object me)
{
	write(@HELP
O榡 : get <~W> [from <eW>]
 
oӫOiHA߰_aWήeY˪~.
 
HELP
    );
    return 1;
}
 
