// remove.c

#include <ansi.h>

inherit F_CLEAN_UP;

int do_remove(object me, object ob);

int main(object me, string arg)
{
	object ob, *inv;
	int i;

	if( !arg ) return notify_fail("An汼S\n");

	if(arg=="all") {
		inv = all_inventory(me);
		for(i=0; i<sizeof(inv); i++)
			do_remove(me, inv[i]);
		write("Ok.\n");
		return 1;
	}

	if( !objectp(ob = present(arg, me)) )
		return notify_fail("AWSo˪FC\n");
	return do_remove(me, ob);
}

int do_remove(object me, object ob)
{
	string str;

	if( (string)ob->query("equipped")!="worn" )
		return notify_fail("AèS˳Ƴo˪FC\n");

	if( ob->unequip() ) {
		if( !stringp(str = ob->query("unequip_msg")) )
			switch(ob->query("armor_type")) {
				case "cloth":
				case "armor":
				case "surcoat":
				case "boots":
					str = YEL "$NN$nFUӡC\n" NOR;
					break;
				default:
					str = YEL "$N$n˳ơC\n" NOR;
			}
		message_vision(str, me, ob);
		return 1;
	} else
		return 0;
}
int help(object me)
{
  write(@HELP
O榡 : remove all | <~W>
 
oӫOA汼WY󨾨.
 
HELP
    );
    return 1;
}
 
