// taolord.c

inherit NPC;
inherit F_MASTER;

void create()
{
	set_name("L", ({ "master taolord", "master", "taolord" }) );
	set("nickname", "uH");
	set("gender", "k");
	set("age", 47);
	set("long",
		"LҬO@DQ`׹D̡MAo{L]@ӬO¦⪺M@\n"
		"ӬO⪺MoOu\\ߪkv׷Ҩ췥ҬɪxC\n");

	set("combat_exp", 1000000);
	set("score", 200000);

	set("class", "taoist");

	set("str", 20);
	set("int", 30);
	set("cor", 20);
	set("cps", 30);
	set("spi", 30);

	set("force", 700);
	set("max_force", 700);
	set("force_factor", 3);

	set("atman", 1400);
	set("max_atman", 1400);

	set("mana", 2000);
	set("max_mana", 2000);
	set("mana_factor", 5);

	set("inquiry", ([
		"\\ߪk": "\\ߪkOڭTsܨ]~DҳЪ\\ߪkC\n",
		"Ts": "ڭTs۱iѮv}s߬ܤM@@NNҥH]vC\n"
	]) );

	set("apprentice_available", 3);
	set("chat_chance_combat", 80);
	set("chat_msg_combat", ({
		(: cast_spell, "drainerbolt" :),
		(: cast_spell, "netherbolt" :),
		(: cast_spell, "feeblebolt" :),
		(: cast_spell, "invocation" :),
	}) );

	create_family("Ts", 5, "Ѯv");

	set_skill("literate", 70);
	set_skill("magic", 80);
	set_skill("force", 30);
	set_skill("spells", 100);
	set_skill("scratching", 100);
	set_skill("unarmed", 30);
	set_skill("sword", 40);
	set_skill("parry", 40);
	set_skill("dodge", 40);
	set_skill("gouyee", 60);

	set_skill("taoism", 100);
	set_skill("necromancy", 100);

	map_skill("magic", "taoism");
	map_skill("spells", "necromancy");

	set_temp("apply/dodge", 20);
	set_temp("apply/armor", 20);

	setup();

	carry_object(__DIR__"sword")->wield();
	carry_object(__DIR__"robe")->wear();
	carry_object(__DIR__"hat")->wear();
	carry_object(__DIR__"shoe")->wear();
}

void attempt_apprentice(object ob)
{
	if( query("apprentice_available") ) {
		if( find_call_out("do_recruit") != -1 )
			command("say CۡM@Ӥ@ӨӡC");
		else
			call_out("do_recruit", 2, ob);
	} else {
		command("say hDѤwgFTӧ̤lMQA{FC");
	}
}

void do_recruit(object ob)
{
	if( (string)ob->query("gender") != "k" )
		command("say hDOXaHMKk{MooFC");
	else {
		command("say ... QJڭTsS]n....");
		command("recruit " + ob->query("id") );
	}
}

int recruit_apprentice(object ob)
{
	if( ::recruit_apprentice(ob) )
		ob->set("class", "taoist");
	add("apprentice_availavble", -1);
}

