// gargoyle.c

#include <ansi.h>
#include <login.h>

inherit NPC;

string *death_msg = ({
	HIB "µL`DRޡTsӪMAsWrS\n\n" NOR,
	HIB "µL`Ω_nۧAMnnݬA@C\n\n" NOR,
	HIB "µL`uv@nMqSǥX@bUF½ݵۡC\n\n" NOR,
	HIB "µL`פWUlMDRxSإɡSiS\n\n" NOR,
	HIB "µL`kFkYM۹DR}F}FMAaC\n\n"
		"@ѳN@MX{Mܧ֦a]FAC\n\n" NOR,
});

void create()
{
	set_name("µL`", ({ "black gargoyle", "gargoyle" }) );
	set("long",
		"µL`۪YۧAMKªyWݤX߫s֡C\n");
	set("attitude", "peaceful");
	set("chat_chance", 15);
	set("chat_msg", ({
		(: this_object(), "random_move" :),
		"µL`oX@}DunMLo{A`ۥLɭԡMFA@C\n",
		"µL`YXӡMwwaQFQۤvS¤SC\n"
	}) );
	set("age", 217);
	set("combat_exp", 20000);
	set("max_gin", 900);
	set("max_kee", 900);
	set("max_sen", 200);
	set_skill("dodge", 40);
	set_skill("unarmed", 40);
	set_temp("apply/armor", 60);
	set_temp("apply/damage", 20);
	setup();
}

void init()
{
	::init();
	if( !previous_object()
	||	!userp(previous_object()) )
		return;
	call_out( "death_stage", 5, previous_object(), 0 );
}

void death_stage(object ob, int stage)
{
	if( !ob || !present(ob) ) return;

	if( !ob->is_ghost() ) {
		command("say ޡTHӳS");
		kill_ob(ob);
		ob->fight_ob(this_object());
		return;
	}

	tell_object(ob, death_msg[stage]);
	if( ++stage < sizeof(death_msg) ) {
		call_out( "death_stage", 5, ob, stage );
		return;
	} else
		ob->reincarnate();

	ob->move(REVIVE_ROOM);
	message("vision",
		"AMo{ehF@ӤHvMLHvSnwgb\n"
		"ܤ[FMuOA@SoıC\n", environment(ob), ob);
}


