// six-chaos-sword.c

#include <ansi.h>

inherit SKILL;

mapping *action = ({
	([	"name":			"s]ûR",
		"action":		"$NϤ@ۡus]ûRvM⤤$wgJBaV$n$lsƼC",
		"dodge":		50,
		"damae":		300,
		"damage_type":	""
	]),
	([	"name":			"F",
		"action":		"$NΤ@M@ۡuF񨭡v$w٦V$n$l",
		"dodge":		-50,
		"damae":		20,
		"damage_type":	""
	]),
	([	"name":			"ʰ]",
		"action":		"$NR$wM@ۡuʰ]v۰{{CV$n$l",
		"dodge":		-40,
		"damage_type":	""
	]),
	([	"name":			"jd",
		"action":		"$N⤤$w@ݡMϥXujdv$n$lX@C",
		"dodge":		-40,
		"damage":		40,
		"damage_type":	""
	]),
	([	"name":			"vll",
		"action":		"$N⤤$wCɪM@ۡuvllv$n$lh",
		"dodge":		-60,
		"damage":		20,
		"damage_type":	""
	]),
	([	"name":			"X",
		"action":		"$N⤤$w$n$lM@ۡuXۡvoXGHCh",
		"dodge":		-20,
		"damage":		50,
		"damage_type":	""
	]),
});

int valid_learn(object me)
{
	object ob;

	if( (int)me->query("max_force") < 100 )
		return notify_fail("AOMSkmlCC\n");

	if( !(ob = me->query_temp("weapon"))
	||	(string)ob->query("skill_type") != "sword" )
		return notify_fail("A@C~mCkC\n");

	return 1;
}

int valid_skill_usage(string usage)
{
	return usage=="sword" || usage=="parry";
}

mapping query_action(object me, object weapon)
{
	return action[random(sizeof(action))];
}

int practice_skill(object me)
{
	if( (int)me->query("kee") < 30
	||	(int)me->query("force") < 5 )
		return notify_fail("AOή𤣰MSkmߤlCC\n");
	me->receive_damage("kee", 30);
	me->add("force", -5);
	write("A۩ҾǽmF@MlCkC\n");
	return 1;
}

int valid_effect(object me, object weapon, string name, int skill)
{
}

void skill_improved(object me)
{
	if( (int)me->query_skill("six-chaos-sword", 1)	% 10 == 0 ) {
		tell_object(me,
			RED "\nAMıo@ѴcĤWYMuıoQH....\n\n" NOR);
		me->add("bellicosity", 1000);
	} else
		me->add("bellicosity", 100);
}
