// Room: /d/snow/weapon_storage.c

inherit ROOM;

void create()
{
	set("short", "Lxë");
	set("long", @LONG
oO@ﺡULBMxëǡMUZ̷ӺB
uB̦b@_MåBo@ФVMxëǪXfbAnM
Xf䦳@Ӭ[l(shelf)C
LONG
	);
	set("exits", ([
		"south" : __DIR__"school2",
	]));
	set("objects", ([
		__DIR__"npc/obj/bamboo_sword": 1,
	]) );
	set("item_desc", ([
		"shelf": "oӬ[lWſM]SwwsǹФ]SC\n"
	]) );

	setup();
}

void init()
{
	add_action("do_push", "push");
}

void check_trigger()
{
	object room;

	if( (int)query("left_trigger")==3
	&&	(int)query("right_trigger")==5
	&&	!query("exits/down") ) {
		message("vision", "aOMoXnM@awwʵۡMSX@ӦVUC\n",
			this_object() );
		set("exits/down", __DIR__"secrect_storage");
		if( room = find_object(__DIR__"secrect_storage") ) {
			room->set("exits/up", __FILE__);
			message("vision", "ѪOMoXnMSX@ӦVWC\n",
				room );
		}
		delete("left_trigger");
		delete("right_trigger");
		call_out("close_passage", 10);
	}
}

void close_passage()
{
	object room;

	if( !query("exits/down") ) return;
	message("vision", "aOMoXnM@awwʵۡMNVUqD\\FC\n",
		this_object() );
	if( room = find_object(__DIR__"secrect_storage") ) {
		room->delete("exits/up");
		message("vision", "ѪOMoXnMVWSwwaF^hC\n",
			room );
	}
	delete("exits/down");
}


int do_push(string arg)
{
	string dir;

	if( !arg || arg=="" ) return 0;

	if( arg=="shelf" ) {
		write("Aյ۱ʳoӬ[lMGiHkư....\n");
		return 1;
	}
	if( sscanf(arg, "shelf %s", dir)==1 ) {
		if( dir=="right" ) {
			message_vision("$NN[lk...MMuءv@n[lS^C\n", this_player());
			add("right_trigger", 1);
			check_trigger();
			return 1;
		} else if( dir=="left" ) {
			message_vision("$NN[l...MMuءv@n[lS^C\n", this_player());
			add("left_trigger", 1);
			check_trigger();
			return 1;
		} else {
			write("AnN[lVӤVS\n");
			return 1;
		}
	}
}


void reset()
{
	::reset();
	delete("left_trigger");
	delete("right_trigger");
}
