// entrance.c

#include <login.h>
#include <room.h>
#include <ansi.h>

inherit ROOM;

void create()
{
	set("short", "Ův|ȫ");
	set("long",
		"o̬OŮvMaѪaMpGANnŮv̪DMbo\n"
	"dO̧֪~|MLpGOCDMбzTwڭ̴Ѫ\n"
	"̨SMAXðݡMŮvDn¾däOЪap󪱡C\n"
	"    FHMziHbo|(accuse)YӪaMӦWa|Qh\n"
	"@ǤppMثeo\\|󭭨MФŧQΨZOHC\n");
	set("exits", ([
		"west" : "/d/wiz/hall1",
		"southeast": "/d/snow/inn" ]) );
	set("no_fight", 1);
	set("no_magic", 1);
	create_door("southeast", "", "northwest", DOOR_CLOSED);

	setup();
	call_other( "/obj/board/query_b", "???" );
}

int valid_leave(object me, string dir)
{
	if( dir=="west" && !wizardp(me) )
		return notify_fail("̥uŮv~ihC\n");
	return ::valid_leave(me, dir);
}

void init()
{
	add_action("do_accuse", "accuse");
}

int do_accuse(string arg)
{
	object ob;
	string s;

	if( (int)this_player()->query("age") < 15 )
		return notify_fail("A~ӤpFMS|OHvOC\n");

	if( !arg ) return notify_fail("An|֡S\n");
	if( ob = find_player(arg) ) {
		if( ob==this_player() )
			return notify_fail("An|ۤvS\n");
		if( ob->is_ghost() )
			return notify_fail( ob->name(1) + "wgFML@aC\n");
		if( wizardp(ob) )
			return notify_fail("A|ŮvC\n");
		tell_object(ob, HIW + this_player()->name(1) + "|AOӾHMЧA@ӤppC\n" NOR);
		ROBOT_CHECK->test_me(ob);
		write("Ok. wgNA|HehC\n");
		write("FקKHξH|ZOHMЧA]ۦPC\n");
		ROBOT_CHECK->test_me(this_player());
		log_file("robot_accuse",
			sprintf("%s accused %s on %s.\n", this_player()->query("id"), ob->query("id"), ctime(time())));
		return 1;
	}
	return notify_fail("ثeuWèSo쪱aC\n");
}

