void user_dump(int type)
{
	switch(type) {
		case DUMP_NET_DEAD:
			tell_room( environment(), query("name") + "_uWL "
				+ NET_DEAD_TIMEOUT/60 + " M۰ʰhXoӥ@ɡC\n");
			command("quit");
			break;
		case DUMP_IDLE:
			tell_object( this_object(), "藍_MzwgobWL " 
				+ IDLE_TIMEOUT/60 + " FMФUAӡC\n");
			tell_room( environment(), "@}jӡMNob" + query("name")
				+ "Ƭ@ﭸǡMFC\n", ({this_object()}));
			command("quit");
			break;
		default: return;
	}
}

// net_dead: called by the gamedriver when an interactive player loses
// hir network connection to the mud.
void net_dead()
{
	object link_ob;

	set_heart_beat(0);
	if( objectp(link_ob = query_temp("link_ob")) )
		destruct(link_ob);

	// Stop fighting, we'll be back soon.
	remove_all_enemy();

	set_temp("netdead", 1);
	if( userp(this_object()) ) {
		call_out("user_dump", NET_DEAD_TIMEOUT, DUMP_NET_DEAD);
	    tell_room(environment(), query("name") + "_uFC\n", this_object());
	    CHANNEL_D->do_channel(this_object(), "sys", "_uFC\n");
	} else {
		command("quit");
	}
}

// reconnect: called by the logind.c daemon when a netdead player reconnects.
void reconnect()
{
	set_heart_beat(1);
	set_temp("netdead",0);
	remove_call_out("user_dump");
	tell_object(this_object(), "ssuC\n");
}

