// corpse.c

inherit ITEM;

int decayed;

void create()
{
	set_name("LW", ({ "corpse" }) );
	set("long", "oO@LWC\n");
	set("unit", "" );
	decayed = 0;
	if( clonep(this_object()) ) call_out("decay", 120, 1);
}

int is_corpse() { return decayed < 2; }
int is_character() { return decayed < 1; }
int is_container() { return 1; }

string short() { return name() + "(" + capitalize(query("id")) + ")"; }

void decay(int phase)
{
	decayed = phase;
	switch(phase) {
		case 1:
			say( query("name") + "}lGFMoX@DcC\n" );
			switch(query("gender")) {
				case "k":
					set_name("Gꪺk", ({ "corpse", "" }) );
				case "k":
					set_name("Gꪺk", ({ "corpse", "" }) );
				default:
					set_name("Gꪺ", ({ "corpse", "" }) );
			}
			set("long",	"oMwgbo̦@qɶFMoۤ@ѻGͪDC\n");
			call_out("decay", 120, phase + 1);
			break;
		case 2:
			say( query("name") + "QjFMܦ@eC\n" );
			set_name("@\\e", ({ "skeleton", "e" }) );
			set("long", "oewgbo̫ܤ[FC\n");
			call_out("decay", 60, phase + 1);
			break;
		case 3:
			say( "@}jLM" + query("name") + "ƦǧjFC\n" );
			destruct(this_object());
			break;
	}
}

object animate(object who, int time)
{
	object zombie;

	if( !environment() ) return 0;

	seteuid(getuid());
	zombie = new("/obj/npc/zombie");
	zombie->set_name( (string)query("victim_name") + "L", ({ "zombie" }) );
	zombie->move(environment());
	zombie->animate(who, time);

	destruct(this_object());
	return zombie;
}
