// mind_beast.c

inherit NPC;

void create()
{
	set_name("[Q~", ({ "mind beast", "beast" }) );
	set("race", "~");
	set("age", 3);
	set("long", "oO@ѭ׹DHҤƪ[Q~M|HzC\n");
	
	set("str", 48);
	set("cor", 52);
	set("cps", 22);

	set("max_kee", 600);
	set("max_gin", 600);
	set("max_sen", 900);

	set("limbs", ({ "Y", "", "e}", "}", "" }) );
	set("verbs", ({ "bite", "claw" }) );

	if( this_player() ) {
		set("combat_exp", this_player()->query_skill("spells", 1) * 2000);
		set("bellicosity", this_player()->query("bellicosity") );
	}
	
	set_temp("apply/attack", 60);
	set_temp("apply/armor", 40);

	setup();
}

void die()
{
	string owner;
	object owner_ob;

	owner = query("owner");

	if( objectp(owner_ob = find_player(owner)) ) {
		if( (object)query_temp("last_damage_from") != owner_ob ) {
			tell_object(owner_ob, "A[Q~QHFT\nAıo@}ѱۦa....\n");
			owner_ob->unconcious();
		} else {
			tell_object(owner_ob, "AFA[Q~MåBqF@ǩGNDzC\n");
			owner_ob->improve_skill("spells", random(owner_ob->query("spi"))+1);
		}
	}
	::die();
}
